--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
@@ -19,10 +19,10 @@
  * CDDL HEADER END
  */
 
-/* Copyright 2010 QLogic Corporation */
+/* Copyright 2015 QLogic Corporation */
 
 /*
- * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
  */
 
 /*
@@ -29,7 +29,7 @@
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  */
 
-#pragma ident	"Copyright 2010 QLogic Corporation; ql_xioctl.c"
+#pragma ident	"Copyright 2015 QLogic Corporation; ql_xioctl.c"
 
 /*
  * ISP2xxx Solaris Fibre Channel Adapter (FCA) driver source file.
@@ -37,7 +37,7 @@
  * ***********************************************************************
  * *									**
  * *				NOTICE					**
- * *		COPYRIGHT (C) 1996-2010 QLOGIC CORPORATION		**
+ * *		COPYRIGHT (C) 1996-2015 QLOGIC CORPORATION		**
  * *			ALL RIGHTS RESERVED				**
  * *									**
  * ***********************************************************************
@@ -51,6 +51,7 @@
 #include <ql_iocb.h>
 #include <ql_ioctl.h>
 #include <ql_mbx.h>
+#include <ql_nx.h>
 #include <ql_xioctl.h>
 
 /*
@@ -96,7 +97,7 @@
 static int ql_report_lun(ql_adapter_state_t *, ql_tgt_t *);
 static int ql_inq_scan(ql_adapter_state_t *, ql_tgt_t *, int);
 static int ql_inq(ql_adapter_state_t *, ql_tgt_t *, int, ql_mbx_iocb_t *,
-    uint8_t);
+    uint32_t);
 static uint32_t	ql_get_buffer_data(caddr_t, caddr_t, uint32_t, int);
 static uint32_t ql_send_buffer_data(caddr_t, caddr_t, uint32_t, int);
 static int ql_24xx_flash_desc(ql_adapter_state_t *);
@@ -116,8 +117,8 @@
 static void ql_set_led_state(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_get_led_state(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_drive_led(ql_adapter_state_t *, uint32_t);
-static uint32_t ql_setup_led(ql_adapter_state_t *);
-static uint32_t ql_wrapup_led(ql_adapter_state_t *);
+static int ql_setup_led(ql_adapter_state_t *);
+static int ql_wrapup_led(ql_adapter_state_t *);
 static void ql_get_port_summary(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_get_target_id(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_get_sfp(ql_adapter_state_t *, EXT_IOCTL *, int);
@@ -152,7 +153,14 @@
 static void ql_get_fcf_list(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_get_resource_counts(ql_adapter_state_t *, EXT_IOCTL *, int);
 static void ql_qry_adapter_versions(ql_adapter_state_t *, EXT_IOCTL *, int);
-static int ql_set_loop_point(ql_adapter_state_t *, uint16_t);
+static void ql_get_temperature(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_dump_cmd(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_serdes_reg(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_serdes_reg_ex(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_els_passthru(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_flash_update_caps(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_get_bbcr_data(ql_adapter_state_t *, EXT_IOCTL *, int);
+static void ql_get_priv_stats(ql_adapter_state_t *, EXT_IOCTL *, int);
 
 /* ******************************************************************** */
 /*			External IOCTL support.				*/
@@ -176,10 +184,10 @@
 {
 	ql_xioctl_t	*xp;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (ha->xioctl != NULL) {
-		QL_PRINT_9(CE_CONT, "(%d): already allocated done\n",
+		QL_PRINT_9(ha, "already allocated done\n",
 		    ha->instance);
 		return (0);
 	}
@@ -200,7 +208,7 @@
 		return (ENOMEM);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (0);
 }
@@ -220,10 +228,10 @@
 {
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (xp == NULL) {
-		QL_PRINT_9(CE_CONT, "(%d): already freed\n", ha->instance);
+		QL_PRINT_9(ha, "already freed\n");
 		return;
 	}
 
@@ -236,7 +244,7 @@
 	kmem_free(xp, sizeof (ql_xioctl_t));
 	ha->xioctl = NULL;
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -266,10 +274,10 @@
 {
 	int	rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started, cmd=%d\n", ha->instance, cmd);
+	QL_PRINT_9(ha, "started, cmd=%d\n", cmd);
 
 	if (ha->xioctl == NULL) {
-		QL_PRINT_9(CE_CONT, "(%d): no context\n", ha->instance);
+		QL_PRINT_9(ha, "no context\n");
 		return (ENXIO);
 	}
 
@@ -306,6 +314,14 @@
 	case EXT_CC_ACCESS_FLASH:
 	case EXT_CC_RESET_FW:
 	case EXT_CC_MENLO_MANAGE_INFO:
+	case EXT_CC_I2C_DATA:
+	case EXT_CC_DUMP:
+	case EXT_CC_SERDES_REG_OP:
+	case EXT_CC_VF_STATE:
+	case EXT_CC_SERDES_REG_OP_EX:
+	case EXT_CC_ELS_PASSTHRU_OS:
+	case EXT_CC_FLASH_UPDATE_CAPS_OS:
+	case EXT_CC_GET_BBCR_DATA_OS:
 		rval = ql_sdm_ioctl(ha, cmd, (void *)arg, mode);
 		break;
 	default:
@@ -314,7 +330,7 @@
 		rval = ENOPROTOOPT;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -348,7 +364,7 @@
 	int			rval;
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Copy argument structure (EXT_IOCTL) from application land. */
 	if ((rval = ql_sdm_setup(ha, &cmd, arg, mode,
@@ -368,8 +384,7 @@
 	 */
 	if (ha->flags & VP_ENABLED) {
 		/* Check that it is within range. */
-		if (cmd->HbaSelect > (CFG_IST(ha, CFG_CTRL_2422) ?
-		    MAX_24_VIRTUAL_PORTS : MAX_25_VIRTUAL_PORTS)) {
+		if (cmd->HbaSelect > ha->max_vports) {
 			EL(ha, "Invalid HbaSelect vp index: %xh\n",
 			    cmd->HbaSelect);
 			cmd->Status = EXT_STATUS_INVALID_VPINDEX;
@@ -393,7 +408,7 @@
 			 * but it's not in the list. Currently this is all
 			 * we can say.
 			 */
-			if (vha == NULL) {
+			if (vha == NULL || !(vha->flags & VP_ENABLED)) {
 				cmd->Status = EXT_STATUS_INVALID_VPINDEX;
 				cmd->ResponseLen = 0;
 				return (EFAULT);
@@ -405,11 +420,14 @@
 	 * If driver is suspended, stalled, or powered down rtn BUSY
 	 */
 	if (ha->flags & ADAPTER_SUSPENDED ||
-	    ha->task_daemon_flags & DRIVER_STALL ||
+	    (ha->task_daemon_flags & (DRIVER_STALL | ISP_ABORT_NEEDED |
+	    ABORT_ISP_ACTIVE | LOOP_RESYNC_NEEDED | LOOP_RESYNC_ACTIVE)) ||
 	    ha->power_level != PM_LEVEL_D0) {
 		EL(ha, " %s\n", ha->flags & ADAPTER_SUSPENDED ?
 		    "driver suspended" :
-		    (ha->task_daemon_flags & DRIVER_STALL ? "driver stalled" :
+		    (ha->task_daemon_flags & (DRIVER_STALL | ISP_ABORT_NEEDED |
+		    ABORT_ISP_ACTIVE | LOOP_RESYNC_NEEDED |
+		    LOOP_RESYNC_ACTIVE) ? "driver stalled" :
 		    "FCA powered down"));
 		cmd->Status = EXT_STATUS_BUSY;
 		cmd->ResponseLen = 0;
@@ -525,6 +543,27 @@
 	case EXT_CC_RESET_FW_OS:
 		ql_reset_cmd(ha, cmd);
 		break;
+	case EXT_CC_I2C_DATA:
+		ql_get_temperature(ha, cmd, mode);
+		break;
+	case EXT_CC_DUMP_OS:
+		ql_dump_cmd(ha, cmd, mode);
+		break;
+	case EXT_CC_SERDES_REG_OP:
+		ql_serdes_reg(ha, cmd, mode);
+		break;
+	case EXT_CC_SERDES_REG_OP_EX:
+		ql_serdes_reg_ex(ha, cmd, mode);
+		break;
+	case EXT_CC_ELS_PASSTHRU_OS:
+		ql_els_passthru(ha, cmd, mode);
+		break;
+	case EXT_CC_FLASH_UPDATE_CAPS_OS:
+		ql_flash_update_caps(ha, cmd, mode);
+		break;
+	case EXT_CC_GET_BBCR_DATA_OS:
+		ql_get_bbcr_data(ha, cmd, mode);
+		break;
 	default:
 		/* function not supported. */
 		EL(ha, "failed, function not supported=%d\n", ioctl_code);
@@ -540,7 +579,7 @@
 		return (EFAULT);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (0);
 }
@@ -572,7 +611,7 @@
 	int		rval;
 	EXT_IOCTL	*cmd;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Allocate local memory for EXT_IOCTL. */
 	*cmd_struct = NULL;
@@ -604,7 +643,7 @@
 	}
 
 	if (rval == 0) {
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 		*cmd_struct = cmd;
 		cmd->Status = EXT_STATUS_OK;
 		cmd->DetailStatus = 0;
@@ -640,7 +679,7 @@
 	 * to return any error status other than the errno.
 	 */
 	if (bcmp(&cmd_struct->Signature, "QLOGIC", 6) != 0) {
-		QL_PRINT_2(CE_CONT, "failed,\n");
+		QL_PRINT_2(NULL, "failed,\n");
 		return (B_FALSE);
 	}
 
@@ -672,7 +711,7 @@
 {
 	int	rval = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	rval |= ddi_copyout((void *)&cmd->ResponseLen,
 	    (void *)&(((EXT_IOCTL*)arg)->ResponseLen), sizeof (uint32_t),
@@ -693,7 +732,7 @@
 		return (EFAULT);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (0);
 }
@@ -716,7 +755,7 @@
 static void
 ql_query(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started, cmd=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, cmd=%d\n",
 	    cmd->SubCode);
 
 	/* case off on command subcode */
@@ -757,7 +796,7 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -782,7 +821,7 @@
 	uint_t		len;
 	caddr_t		bufp;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_HBA_NODE)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -819,7 +858,7 @@
 			    (uint16_t *)
 			    (ha->sbus_fpga_iobase + FPGA_REVISION));
 
-			tmpptr = (char *)&(tmp_node.DriverVersion[verlen+1]);
+			tmpptr = (char *)&(tmp_node.DriverVersion[verlen + 1]);
 			if (tmpptr == NULL) {
 				EL(ha, "Unable to insert fpga version str\n");
 			} else {
@@ -834,7 +873,7 @@
 	    ha->fw_major_version, ha->fw_minor_version,
 	    ha->fw_subminor_version);
 
-	if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		switch (ha->fw_attributes) {
 		case FWATTRIB_EF:
 			(void) strcat((char *)(tmp_node.FWVersion), " EF");
@@ -879,6 +918,12 @@
 	tmp_node.PortCount = 1;
 	tmp_node.InterfaceType = EXT_DEF_FC_INTF_TYPE;
 
+	tmp_node.MpiVersion[0] = ha->mpi_fw_major_version;
+	tmp_node.MpiVersion[1] = ha->mpi_fw_minor_version;
+	tmp_node.MpiVersion[2] = ha->mpi_fw_subminor_version;
+	tmp_node.PepFwVersion[0] = ha->phy_fw_major_version;
+	tmp_node.PepFwVersion[1] = ha->phy_fw_minor_version;
+	tmp_node.PepFwVersion[2] = ha->phy_fw_subminor_version;
 	if (ddi_copyout((void *)&tmp_node,
 	    (void *)(uintptr_t)(cmd->ResponseAdr),
 	    sizeof (EXT_HBA_NODE), mode) != 0) {
@@ -887,7 +932,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_HBA_NODE);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -911,12 +956,12 @@
 {
 	ql_link_t	*link;
 	ql_tgt_t	*tq;
-	ql_mbx_data_t	mr;
+	ql_mbx_data_t	mr = {0};
 	EXT_HBA_PORT	tmp_port = {0};
 	int		rval;
 	uint16_t	port_cnt, tgt_cnt, index;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_HBA_PORT)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -976,6 +1021,12 @@
 		case IIDMA_RATE_10GB:
 			tmp_port.PortSpeed = EXT_DEF_PORTSPEED_10GBIT;
 			break;
+		case IIDMA_RATE_16GB:
+			tmp_port.PortSpeed = EXT_DEF_PORTSPEED_16GBIT;
+			break;
+		case IIDMA_RATE_32GB:
+			tmp_port.PortSpeed = EXT_DEF_PORTSPEED_32GBIT;
+			break;
 		default:
 			tmp_port.PortSpeed = EXT_DEF_PORTSPEED_UNKNOWN;
 			EL(ha, "failed, data rate=%xh\n", mr.mb[1]);
@@ -1013,23 +1064,39 @@
 			break;
 
 		}
-	} else if (CFG_IST(ha, CFG_CTRL_8081)) {
+	} else if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
 		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_10GBIT;
-	} else if (CFG_IST(ha, CFG_CTRL_2422)) {
+	} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		tmp_port.PortSupportedSpeed = (EXT_DEF_PORTSPEED_4GBIT |
 		    EXT_DEF_PORTSPEED_2GBIT | EXT_DEF_PORTSPEED_1GBIT);
-	} else if (CFG_IST(ha, CFG_CTRL_2300)) {
+	} else if (CFG_IST(ha, CFG_CTRL_23XX)) {
 		tmp_port.PortSupportedSpeed = (EXT_DEF_PORTSPEED_2GBIT |
 		    EXT_DEF_PORTSPEED_1GBIT);
-	} else if (CFG_IST(ha, CFG_CTRL_6322)) {
+	} else if (CFG_IST(ha, CFG_CTRL_63XX)) {
 		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_2GBIT;
-	} else if (CFG_IST(ha, CFG_CTRL_2200)) {
+	} else if (CFG_IST(ha, CFG_CTRL_22XX)) {
 		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_1GBIT;
+	} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_4GBIT |
+		    EXT_DEF_PORTSPEED_8GBIT | EXT_DEF_PORTSPEED_16GBIT;
+	} else if (CFG_IST(ha, CFG_CTRL_27XX)) {
+		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_4GBIT |
+		    EXT_DEF_PORTSPEED_8GBIT | EXT_DEF_PORTSPEED_16GBIT |
+		    EXT_DEF_PORTSPEED_32GBIT;
 	} else {
 		tmp_port.PortSupportedSpeed = EXT_DEF_PORTSPEED_UNKNOWN;
 		EL(ha, "unknown HBA type: %xh\n", ha->device_id);
 	}
+
+	if (ha->task_daemon_flags & LOOP_DOWN) {
+		(void) ql_get_firmware_state(ha, NULL);
+	}
+
+	tmp_port.LinkState1 = ha->fw_state[1];
 	tmp_port.LinkState2 = LSB(ha->sfp_stat);
+	tmp_port.LinkState3 = ha->fw_state[3];
+	tmp_port.LinkState6 = ha->fw_state[6];
+
 	port_cnt = 0;
 	tgt_cnt = 0;
 
@@ -1038,10 +1105,16 @@
 		    link = link->next) {
 			tq = link->base_address;
 
-			if (!VALID_TARGET_ID(ha, tq->loop_id)) {
+			if (!VALID_TARGET_ID(ha, tq->loop_id) ||
+			    tq->d_id.b24 == FS_MANAGEMENT_SERVER) {
 				continue;
 			}
 
+			if (tq->flags & (TQF_RSCN_RCVD | TQF_IIDMA_NEEDED |
+			    TQF_NEED_AUTHENTICATION | TQF_PLOGI_PROGRS)) {
+				continue;
+			}
+
 			port_cnt++;
 			if ((tq->flags & TQF_INITIATOR_DEVICE) == 0) {
 				tgt_cnt++;
@@ -1063,7 +1136,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_HBA_PORT);
-		QL_PRINT_9(CE_CONT, "(%d): done, ports=%d, targets=%d\n",
+		QL_PRINT_9(ha, "done, ports=%d, targets=%d\n",
 		    ha->instance, port_cnt, tgt_cnt);
 	}
 }
@@ -1094,7 +1167,7 @@
 	uint16_t	index;
 	uint16_t	inst = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_DISC_PORT)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -1111,9 +1184,16 @@
 		    link = link->next) {
 			tq = link->base_address;
 
-			if (!VALID_TARGET_ID(ha, tq->loop_id)) {
+			if (!VALID_TARGET_ID(ha, tq->loop_id) ||
+			    tq->d_id.b24 == FS_MANAGEMENT_SERVER) {
 				continue;
 			}
+
+			if (tq->flags & (TQF_RSCN_RCVD | TQF_IIDMA_NEEDED |
+			    TQF_NEED_AUTHENTICATION | TQF_PLOGI_PROGRS)) {
+				continue;
+			}
+
 			if (inst != cmd->Instance) {
 				inst++;
 				continue;
@@ -1171,7 +1251,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_DISC_PORT);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1201,7 +1281,7 @@
 	uint16_t	index;
 	uint16_t	inst = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started, target=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, target=%d\n",
 	    cmd->Instance);
 
 	if (cmd->ResponseLen < sizeof (EXT_DISC_TARGET)) {
@@ -1221,7 +1301,8 @@
 			tq = link->base_address;
 
 			if (!VALID_TARGET_ID(ha, tq->loop_id) ||
-			    tq->flags & TQF_INITIATOR_DEVICE) {
+			    tq->flags & TQF_INITIATOR_DEVICE ||
+			    tq->d_id.b24 == FS_MANAGEMENT_SERVER) {
 				continue;
 			}
 			if (inst != cmd->Instance) {
@@ -1283,7 +1364,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_DISC_TARGET);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1307,7 +1388,7 @@
 {
 	EXT_FW		fw_info = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_FW)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -1333,7 +1414,7 @@
 		return;
 	} else {
 		cmd->ResponseLen = sizeof (EXT_FW);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1356,8 +1437,9 @@
 ql_qry_chip(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
 	EXT_CHIP	chip = {0};
+	uint16_t	PciDevNumber;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_CHIP)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -1377,10 +1459,15 @@
 	chip.MemAddr = ql_pci_config_get32(ha, PCI_CONF_BASE1);
 	chip.MemAddrLen = 0x100;
 	chip.ChipRevID = ha->rev_id;
-	if (ha->flags & FUNCTION_1) {
-		chip.FuncNo = 1;
-	}
+	chip.FuncNo = ha->pci_function_number;
+	chip.PciBusNumber = (uint16_t)
+	    ((ha->pci_bus_addr & PCI_REG_BUS_M) >> PCI_REG_BUS_SHIFT);
 
+	PciDevNumber = (uint16_t)
+	    ((ha->pci_bus_addr & PCI_REG_DEV_M) >> PCI_REG_DEV_SHIFT);
+	chip.PciSlotNumber = (uint16_t)(((PciDevNumber << 3) & 0xF8) |
+	    (chip.FuncNo & 0x7));
+
 	if (ddi_copyout((void *)&chip,
 	    (void *)(uintptr_t)(cmd->ResponseAdr),
 	    sizeof (EXT_CHIP), mode) != 0) {
@@ -1389,7 +1476,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_CHIP);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1413,7 +1500,7 @@
 {
 	EXT_DRIVER	qd = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_DRIVER)) {
 		cmd->Status = EXT_STATUS_DATA_OVERRUN;
@@ -1427,7 +1514,7 @@
 	(void) strcpy((void *)&qd.Version[0], QL_VERSION);
 	qd.NumOfBus = 1;	/* Fixed for Solaris */
 	qd.TargetsPerBus = (uint16_t)
-	    (CFG_IST(ha, (CFG_CTRL_24258081 | CFG_EXT_FW_INTERFACE)) ?
+	    (CFG_IST(ha, (CFG_ISP_FW_TYPE_2 | CFG_EXT_FW_INTERFACE)) ?
 	    MAX_24_FIBRE_DEVICES : MAX_22_FIBRE_DEVICES);
 	qd.LunsPerTarget = 2030;
 	qd.MaxTransferLen = QL_DMA_MAX_XFER_SIZE;
@@ -1440,7 +1527,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_DRIVER);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1473,10 +1560,10 @@
 	ql_tgt_t		tq;
 	uint16_t		comp_status, loop_id;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Get CT argument structure. */
-	if ((ha->topology & QL_SNS_CONNECTION) == 0) {
+	if ((ha->topology & QL_FABRIC_CONNECTION) == 0) {
 		EL(ha, "failed, No switch\n");
 		cmd->Status = EXT_STATUS_DEV_NOT_FOUND;
 		cmd->ResponseLen = 0;
@@ -1495,7 +1582,7 @@
 		tq.d_id.b.al_pa = 0xfa;
 		tq.d_id.b.area = 0xff;
 		tq.d_id.b.domain = 0xff;
-		tq.loop_id = (uint16_t)(CFG_IST(ha, CFG_CTRL_24258081) ?
+		tq.loop_id = (uint16_t)(CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 		    MANAGEMENT_SERVER_24XX_LOOP_ID :
 		    MANAGEMENT_SERVER_LOOP_ID);
 		rval = ql_login_fport(ha, &tq, tq.loop_id, LFF_NO_PRLI, &mr);
@@ -1509,7 +1596,7 @@
 		}
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): cmd\n", ha->instance);
+	QL_PRINT_9(ha, "cmd\n");
 	QL_DUMP_9(cmd, 8, sizeof (EXT_IOCTL));
 
 	/* Allocate a DMA Memory Descriptor */
@@ -1551,8 +1638,8 @@
 	/* Get DMA memory for the IOCB */
 	if (ql_get_dma_mem(ha, dma_mem, pkt_size, LITTLE_ENDIAN_DMA,
 	    QL_DMA_RING_ALIGN) != QL_SUCCESS) {
-		cmn_err(CE_WARN, "%s(%d): DMA memory "
-		    "alloc failed", QL_NAME, ha->instance);
+		cmn_err(CE_WARN, "%sDMA memory "
+		    "alloc failed", QL_NAME);
 		kmem_free(pkt, pkt_size);
 		kmem_free(dma_mem, sizeof (dma_mem_t));
 		cmd->Status = EXT_STATUS_MS_NO_RESPONSE;
@@ -1572,7 +1659,7 @@
 	 * Setup IOCB
 	 */
 	ct = (ql_ct_iu_preamble_t *)pld;
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		pkt->ms24.entry_type = CT_PASSTHRU_TYPE;
 		pkt->ms24.entry_count = 1;
 
@@ -1597,7 +1684,7 @@
 		/* Load ct rsp byte count. */
 		pkt->ms24.resp_byte_count = LE_32(cmd->ResponseLen);
 
-		long_ptr = (uint32_t *)&pkt->ms24.dseg_0_address;
+		long_ptr = (uint32_t *)&pkt->ms24.dseg;
 
 		/* Load MS command entry data segments. */
 		*long_ptr++ = (uint32_t)
@@ -1659,20 +1746,20 @@
 
 		/* Response total byte count. */
 		pkt->ms.resp_byte_count = LE_32(cmd->ResponseLen);
-		pkt->ms.dseg_1_length = LE_32(cmd->ResponseLen);
+		pkt->ms.dseg[1].length = LE_32(cmd->ResponseLen);
 
 		/* Command total byte count. */
 		pkt->ms.cmd_byte_count = LE_32(cmd->RequestLen);
-		pkt->ms.dseg_0_length = LE_32(cmd->RequestLen);
+		pkt->ms.dseg[0].length = LE_32(cmd->RequestLen);
 
 		/* Load command/response data segments. */
-		pkt->ms.dseg_0_address[0] = (uint32_t)
+		pkt->ms.dseg[0].address[0] = (uint32_t)
 		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-		pkt->ms.dseg_0_address[1] = (uint32_t)
+		pkt->ms.dseg[0].address[1] = (uint32_t)
 		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
-		pkt->ms.dseg_1_address[0] = (uint32_t)
+		pkt->ms.dseg[1].address[0] = (uint32_t)
 		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-		pkt->ms.dseg_1_address[1] = (uint32_t)
+		pkt->ms.dseg[1].address[1] = (uint32_t)
 		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
 
 		rval = ql_issue_mbx_iocb(ha, (caddr_t)pkt,
@@ -1706,7 +1793,7 @@
 
 	/* Copy response payload from DMA buffer to application. */
 	if (cmd->ResponseLen != 0) {
-		QL_PRINT_9(CE_CONT, "(%d): ResponseLen=%d\n", ha->instance,
+		QL_PRINT_9(ha, "ResponseLen=%d\n",
 		    cmd->ResponseLen);
 		QL_DUMP_9(pld, 8, cmd->ResponseLen);
 
@@ -1724,7 +1811,7 @@
 	ql_free_dma_resource(ha, dma_mem);
 	kmem_free(dma_mem, sizeof (dma_mem_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -1749,7 +1836,7 @@
 	int		rval = 0;
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	rval = ddi_copyin((void*)(uintptr_t)cmd->RequestAdr, &reg_struct,
 	    cmd->RequestLen, mode);
@@ -1765,7 +1852,7 @@
 			xp->aen_q_tail = 0;
 			INTR_UNLOCK(ha);
 		}
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	} else {
 		cmd->Status = EXT_STATUS_COPY_ERR;
 		EL(ha, "failed, ddi_copyin\n");
@@ -1798,7 +1885,7 @@
 	uint8_t		request_cnt;
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Compute the number of events that can be returned */
 	request_cnt = (uint8_t)(cmd->ResponseLen / sizeof (EXT_ASYNC_EVENT));
@@ -1855,7 +1942,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = out_size;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -1879,11 +1966,11 @@
 	EXT_ASYNC_EVENT		*aen_queue;
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started, event_code=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, event_code=%d\n",
 	    event_code);
 
 	if (xp == NULL) {
-		QL_PRINT_9(CE_CONT, "(%d): no context\n", ha->instance);
+		QL_PRINT_9(ha, "no context\n");
 		return;
 	}
 	aen_queue = (EXT_ASYNC_EVENT *)xp->aen_tracking_queue;
@@ -1949,7 +2036,7 @@
 		}
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -2013,7 +2100,7 @@
 		uint8_t		scsi_status_h;
 	} sts;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Verify Sub Code and set cnt to needed request size. */
 	if (cmd->SubCode == EXT_SC_SEND_SCSI_PASSTHRU) {
@@ -2069,7 +2156,7 @@
 
 		qlnt = QLNT_PORT;
 		name = (uint8_t *)&sp_req->TargetAddr.Target;
-		QL_PRINT_9(CE_CONT, "(%d): SubCode=%xh, Target=%lld\n",
+		QL_PRINT_9(ha, "SubCode=%xh, Target=%lld\n",
 		    ha->instance, cmd->SubCode, sp_req->TargetAddr.Target);
 		tq = ql_find_port(ha, name, qlnt);
 	} else {
@@ -2079,7 +2166,7 @@
 		if (fc_req->FCScsiAddr.DestType == EXT_DEF_DESTTYPE_WWPN) {
 			qlnt = QLNT_PORT;
 			name = &fc_req->FCScsiAddr.DestAddr.WWPN[0];
-			QL_PRINT_9(CE_CONT, "(%d): SubCode=%xh, "
+			QL_PRINT_9(ha, "SubCode=%xh, "
 			    "wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 			    ha->instance, cmd->SubCode, name[0], name[1],
 			    name[2], name[3], name[4], name[5], name[6],
@@ -2089,7 +2176,7 @@
 		    EXT_DEF_DESTTYPE_WWNN) {
 			qlnt = QLNT_NODE;
 			name = &fc_req->FCScsiAddr.DestAddr.WWNN[0];
-			QL_PRINT_9(CE_CONT, "(%d): SubCode=%xh, "
+			QL_PRINT_9(ha, "SubCode=%xh, "
 			    "wwnn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 			    ha->instance, cmd->SubCode, name[0], name[1],
 			    name[2], name[3], name[4], name[5], name[6],
@@ -2099,8 +2186,8 @@
 		    EXT_DEF_DESTTYPE_PORTID) {
 			qlnt = QLNT_PID;
 			name = &fc_req->FCScsiAddr.DestAddr.Id[0];
-			QL_PRINT_9(CE_CONT, "(%d): SubCode=%xh, PID="
-			    "%02x%02x%02x\n", ha->instance, cmd->SubCode,
+			QL_PRINT_9(ha, "SubCode=%xh, PID="
+			    "%02x%02x%02x\n", cmd->SubCode,
 			    name[0], name[1], name[2]);
 			tq = ql_find_port(ha, name, qlnt);
 		} else {
@@ -2151,8 +2238,8 @@
 		/* Get DMA memory for the IOCB */
 		if (ql_get_dma_mem(ha, dma_mem, pld_size, LITTLE_ENDIAN_DMA,
 		    QL_DMA_DATA_ALIGN) != QL_SUCCESS) {
-			cmn_err(CE_WARN, "%s(%d): request queue DMA memory "
-			    "alloc failed", QL_NAME, ha->instance);
+			cmn_err(CE_WARN, "%srequest queue DMA memory "
+			    "alloc failed", QL_NAME);
 			kmem_free(pkt, pkt_size);
 			cmd->Status = EXT_STATUS_MS_NO_RESPONSE;
 			cmd->ResponseLen = 0;
@@ -2161,11 +2248,11 @@
 
 		if (scsi_req.direction == EXT_DEF_SCSI_PASSTHRU_DATA_IN) {
 			scsi_req.direction = (uint8_t)
-			    (CFG_IST(ha, CFG_CTRL_24258081) ?
+			    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 			    CF_RD : CF_DATA_IN | CF_STAG);
 		} else {
 			scsi_req.direction = (uint8_t)
-			    (CFG_IST(ha, CFG_CTRL_24258081) ?
+			    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 			    CF_WR : CF_DATA_OUT | CF_STAG);
 			cmd->ResponseLen = 0;
 
@@ -2193,7 +2280,7 @@
 		}
 	} else {
 		scsi_req.direction = (uint8_t)
-		    (CFG_IST(ha, CFG_CTRL_24258081) ? 0 : CF_STAG);
+		    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) ? 0 : CF_STAG);
 		cmd->ResponseLen = 0;
 
 		pkt_size = sizeof (ql_mbx_iocb_t);
@@ -2212,7 +2299,7 @@
 	cmd->Status = EXT_STATUS_OK;
 	cmd->DetailStatus = EXT_DSTATUS_NOADNL_INFO;
 
-	QL_PRINT_9(CE_CONT, "(%d): SCSI cdb\n", ha->instance);
+	QL_PRINT_9(ha, "SCSI cdb\n");
 	QL_DUMP_9(scsi_req.cdbp, 8, scsi_req.cdb_len);
 
 	do {
@@ -2221,14 +2308,34 @@
 			break;
 		}
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
+			uint64_t		lun_addr = 0;
+			fcp_ent_addr_t		*fcp_ent_addr = 0;
+
 			pkt->cmd24.entry_type = IOCB_CMD_TYPE_7;
 			pkt->cmd24.entry_count = 1;
 
-			/* Set LUN number */
-			pkt->cmd24.fcp_lun[2] = LSB(scsi_req.lun);
-			pkt->cmd24.fcp_lun[3] = MSB(scsi_req.lun);
+			/* Set LUN number and address method */
+			lun_addr = ql_get_lun_addr(tq, scsi_req.lun);
+			fcp_ent_addr = (fcp_ent_addr_t *)&lun_addr;
 
+			pkt->cmd24.fcp_lun[2] =
+			    lobyte(fcp_ent_addr->ent_addr_0);
+			pkt->cmd24.fcp_lun[3] =
+			    hibyte(fcp_ent_addr->ent_addr_0);
+			pkt->cmd24.fcp_lun[0] =
+			    lobyte(fcp_ent_addr->ent_addr_1);
+			pkt->cmd24.fcp_lun[1] =
+			    hibyte(fcp_ent_addr->ent_addr_1);
+			pkt->cmd24.fcp_lun[6] =
+			    lobyte(fcp_ent_addr->ent_addr_2);
+			pkt->cmd24.fcp_lun[7] =
+			    hibyte(fcp_ent_addr->ent_addr_2);
+			pkt->cmd24.fcp_lun[4] =
+			    lobyte(fcp_ent_addr->ent_addr_3);
+			pkt->cmd24.fcp_lun[5] =
+			    hibyte(fcp_ent_addr->ent_addr_3);
+
 			/* Set N_port handle */
 			pkt->cmd24.n_port_hdl = (uint16_t)LE_16(tq->loop_id);
 
@@ -2244,9 +2351,9 @@
 			pkt->cmd24.timeout = (uint16_t)LE_16(15);
 
 			/* Load SCSI CDB */
-			ddi_rep_put8(ha->hba_buf.acc_handle, scsi_req.cdbp,
-			    pkt->cmd24.scsi_cdb, scsi_req.cdb_len,
-			    DDI_DEV_AUTOINCR);
+			ddi_rep_put8(ha->req_q[0]->req_ring.acc_handle,
+			    scsi_req.cdbp, pkt->cmd24.scsi_cdb,
+			    scsi_req.cdb_len, DDI_DEV_AUTOINCR);
 			for (cnt = 0; cnt < MAX_CMDSZ;
 			    cnt = (uint16_t)(cnt + 4)) {
 				ql_chg_endian((uint8_t *)&pkt->cmd24.scsi_cdb
@@ -2267,11 +2374,11 @@
 				pkt->cmd24.total_byte_count = LE_32(pld_size);
 
 				/* Load data descriptor. */
-				pkt->cmd24.dseg_0_address[0] = (uint32_t)
+				pkt->cmd24.dseg.address[0] = (uint32_t)
 				    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-				pkt->cmd24.dseg_0_address[1] = (uint32_t)
+				pkt->cmd24.dseg.address[1] = (uint32_t)
 				    LE_32(MSD(dma_mem->cookie.dmac_laddress));
-				pkt->cmd24.dseg_0_length = LE_32(pld_size);
+				pkt->cmd24.dseg.length = LE_32(pld_size);
 			}
 		} else if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING)) {
 			pkt->cmd3.entry_type = IOCB_CMD_TYPE_3;
@@ -2292,11 +2399,11 @@
 			if (pld_size) {
 				pkt->cmd3.dseg_count = LE_16(1);
 				pkt->cmd3.byte_count = LE_32(pld_size);
-				pkt->cmd3.dseg_0_address[0] = (uint32_t)
+				pkt->cmd3.dseg[0].address[0] = (uint32_t)
 				    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-				pkt->cmd3.dseg_0_address[1] = (uint32_t)
+				pkt->cmd3.dseg[0].address[1] = (uint32_t)
 				    LE_32(MSD(dma_mem->cookie.dmac_laddress));
-				pkt->cmd3.dseg_0_length = LE_32(pld_size);
+				pkt->cmd3.dseg[0].length = LE_32(pld_size);
 			}
 		} else {
 			pkt->cmd.entry_type = IOCB_CMD_TYPE_2;
@@ -2317,13 +2424,13 @@
 			if (pld_size) {
 				pkt->cmd.dseg_count = LE_16(1);
 				pkt->cmd.byte_count = LE_32(pld_size);
-				pkt->cmd.dseg_0_address = (uint32_t)
+				pkt->cmd.dseg[0].address = (uint32_t)
 				    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-				pkt->cmd.dseg_0_length = LE_32(pld_size);
+				pkt->cmd.dseg[0].length = LE_32(pld_size);
 			}
 		}
 		/* Go issue command and wait for completion. */
-		QL_PRINT_9(CE_CONT, "(%d): request pkt\n", ha->instance);
+		QL_PRINT_9(ha, "request pkt\n");
 		QL_DUMP_9(pkt, 8, pkt_size);
 
 		status = ql_issue_mbx_iocb(ha, (caddr_t)pkt, pkt_size);
@@ -2338,7 +2445,7 @@
 			    DDI_DEV_AUTOINCR);
 		}
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			pkt->sts24.entry_status = (uint8_t)
 			    (pkt->sts24.entry_status & 0x3c);
 		} else {
@@ -2352,7 +2459,8 @@
 			status = QL_FUNCTION_PARAMETER_ERROR;
 		}
 
-		sts.comp_status = (uint16_t)(CFG_IST(ha, CFG_CTRL_24258081) ?
+		sts.comp_status = (uint16_t)
+		    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 		    LE_16(pkt->sts24.comp_status) :
 		    LE_16(pkt->sts.comp_status));
 
@@ -2415,7 +2523,7 @@
 	}
 
 	/* Setup status. */
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		sts.scsi_status_l = pkt->sts24.scsi_status_l;
 		sts.scsi_status_h = pkt->sts24.scsi_status_h;
 
@@ -2490,7 +2598,7 @@
 		sts.req_sense_data = &pkt->sts.req_sense_data[0];
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): response pkt\n", ha->instance);
+	QL_PRINT_9(ha, "response pkt\n");
 	QL_DUMP_9(&pkt->sts, 8, sizeof (sts_entry_t));
 
 	switch (sts.comp_status) {
@@ -2554,11 +2662,11 @@
 	/* Correct ISP completion status */
 	if (sts.comp_status == CS_COMPLETE && sts.scsi_status_l == 0 &&
 	    (sts.scsi_status_h & FCP_RSP_MASK) == 0) {
-		QL_PRINT_9(CE_CONT, "(%d): Correct completion\n",
+		QL_PRINT_9(ha, "Correct completion\n",
 		    ha->instance);
 		scsi_req.resid = 0;
 	} else if (sts.comp_status == CS_DATA_UNDERRUN) {
-		QL_PRINT_9(CE_CONT, "(%d): Correct UNDERRUN\n",
+		QL_PRINT_9(ha, "Correct UNDERRUN\n",
 		    ha->instance);
 		scsi_req.resid = sts.residual_length;
 		if (sts.scsi_status_h & FCP_RESID_UNDER) {
@@ -2572,8 +2680,8 @@
 			cmd->ResponseLen = 0;
 		}
 	} else {
-		QL_PRINT_9(CE_CONT, "(%d): error d_id=%xh, comp_status=%xh, "
-		    "scsi_status_h=%xh, scsi_status_l=%xh\n", ha->instance,
+		QL_PRINT_9(ha, "error d_id=%xh, comp_status=%xh, "
+		    "scsi_status_h=%xh, scsi_status_l=%xh\n",
 		    tq->d_id.b24, sts.comp_status, sts.scsi_status_h,
 		    sts.scsi_status_l);
 
@@ -2638,8 +2746,8 @@
 	/* Copy response payload from DMA buffer to application. */
 	if (scsi_req.direction & (CF_RD | CF_DATA_IN) &&
 	    cmd->ResponseLen != 0) {
-		QL_PRINT_9(CE_CONT, "(%d): Data Return resid=%lu, "
-		    "byte_count=%u, ResponseLen=%xh\n", ha->instance,
+		QL_PRINT_9(ha, "Data Return resid=%lu, "
+		    "byte_count=%u, ResponseLen=%xh\n",
 		    scsi_req.resid, pld_size, cmd->ResponseLen);
 		QL_DUMP_9(pld, 8, cmd->ResponseLen);
 
